#
# Skeleton PloneTestCase
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase

ZopeTestCase.installProduct('CMFReportTool')

from Products.CMFReportTool.html2pml import Html2Pml

class TestHTML2PML(ZopeTestCase.ZopeTestCase):

    def afterSetUp(self):
        self.h2p = Html2Pml()


    def _convert(self, html=''):
        return self.h2p.convert(html, isXHTML=True)
        
    def testSimple(self):
        input = '<p>text</p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text</para>')

    def testSubInP(self):
        input = '<p>text<sub>sub</sub></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<sub>sub</sub></para>')

    def testSuperInP(self):
        input = '<p>text<super>super</super></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<super>super</super></para>')

    def testSubInB(self):
        input = '<p>text<b><sub>sub</sub></b></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<b><sub>sub</sub></b></para>')

    def testSuperInB(self):
        input = '<p>text<b><super>super</super></b></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<b><super>super</super></b></para>')

    def testBInSub(self):
        input = '<p>text<sub><b>sub</b></sub></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<sub><b>sub</b></sub></para>')

    def testBInSuper(self):
        input = '<p>text<super><b>super</b></super></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<super><b>super</b></super></para>')

    def testSubInU(self):
        input = '<p>text<u><sub>sub</sub></u></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<u><sub>sub</sub></u></para>')

    def testSuperInU(self):
        input = '<p>text<u><super>super</super></u></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<u><super>super</super></u></para>')

    def testUInSub(self):
        input = '<p>text<sub><u>sub</u></sub></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<sub><u>sub</u></sub></para>')

    def testUInSuper(self):
        input = '<p>text<super><u>super</u></super></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<super><u>super</u></super></para>')

    def testSubInA(self):
        input = '<p>text<a href="http://plone.org"><sub>sub</sub></a></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<a href="http://plone.org"><sub>sub</sub></a></para>')

    def testSuperInA(self):
        input = '<p>text<a href="http://plone.org"><super>super</super></a></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<a href="http://plone.org"><super>super</super></a></para>')

    def testAInSub(self):
        input = '<p>text<sub><a href="http://plone.org">sub</a></sub></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<sub><a href="http://plone.org">sub</a></sub></para>')

    def testAInSuper(self):
        input = '<p>text<super><a href="http://plone.org">super</a></super></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<super><a href="http://plone.org">super</a></super></para>')

    def testSubInFont(self):
        input = '<p>text<font face="Helvetica"><sub>sub</sub></font></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<font face="Helvetica"><sub>sub</sub></font></para>')

    def testSuperInFont(self):
        input = '<p>text<font face="Helvetica"><super>super</super></font></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<font face="Helvetica"><super>super</super></font></para>')

    def testFontInSub(self):
        input = '<p>text<sub><font face="Helvetica">sub</font></sub></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<sub><font face="Helvetica">sub</font></sub></para>')

    def testFontInSuper(self):
        input = '<p>text<super><font face="Helvetica">super</font></super></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<super><font face="Helvetica">super</font></super></para>')

    def testSubInI(self):
        input = '<p>text<i><sub>sub</sub></i></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<i><sub>sub</sub></i></para>')

    def testSuperInI(self):
        input = '<p>text<i><super>super</super></i></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<i><super>super</super></i></para>')

    def testIInSub(self):
        input = '<p>text<sub><i>sub</i></sub></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<sub><i>sub</i></sub></para>')

    def testIInSuper(self):
        input = '<p>text<super><i>super</i></super></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<super><i>super</i></super></para>')

    def testBrInSub(self):
        input = '<p>text<sub>first<br/>second</sub></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<sub>first<br/>second</sub></para>')

    def testBrInSuper(self):
        input = '<p>text<super>first<br/>second</super></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<super>first<br/>second</super></para>')

    def testBrInI(self):
        input = '<p>text<i>first<br/>second</i></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<i>first<br/>second</i></para>')

    def testBrInU(self):
        input = '<p>text<u>first<br/>second</u></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<u>first<br/>second</u></para>')

    def testBrInB(self):
        input = '<p>text<b>first<br/>second</b></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<b>first<br/>second</b></para>')

    def testBrInA(self):
        input = '<p>text<a href="http://plone.org">first<br/>second</a></p>'
        output = self.h2p.convert(input, isXHTML=True)
        self.assertEqual(output, '<para style="BodyText">text<a href="http://plone.org">first<br/>second</a></para>')

    def test_table(self):
        table_fragment = """  <table border="1">
    <tbody>
     <tr>
      <th>Gas</th>

      <th>Global warming potential (GWP)</th>
     </tr>

     <tr>
      <td>carbon dioxine</td>

      <td>1</td>
     </tr>

     <tr>
      <td>methane</td>

      <td>21</td>
     </tr>

     <tr>
      <td>nitrous oxide</td>

      <td>310</td>
     </tr>

     <tr>
      <td>sulphur hexafluoride</td>

      <td>23900</td>
     </tr>
    </tbody>
   </table>        
        """
        pml = self._convert(table_fragment)
        
        self.failUnless(pml == '''<table style="StandardTable"><tr><th>Gas</th><th>Global warming potential (GWP)</th></tr><tr><td>carbon dioxine</td><td>1</td></tr><tr><td>methane</td><td>21</td></tr><tr><td>nitrous oxide</td><td>310</td></tr><tr><td>sulphur hexafluoride</td><td>23900</td></tr></table>''')
        
    def test_dl(self):
        ul_fragment ="""
        <dl><dt>A term</dt>
            <dd>Some definition</dd></dl>
        """
        pml = self._convert(ul_fragment)

        self.failUnless( pml == '<para style="BodyText"><dl style="DefinitionList" type=""><dt>A term</dt><dd>Some definition</dd></dl></para>')

        ul_fragment ="""
        <h3>A heading</h3>
        <dl><dt>A term</dt>
            <dd>Some definition</dd></dl>
        """
        pml = self._convert(ul_fragment)

        self.failUnless( pml == '''<para style="Heading3">A heading</para><para style="BodyText"><dl
    style="DefinitionList" type=""><dt>A term</dt><dd>Some definition</dd></dl></para>''')

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestHTML2PML))
    return suite

if __name__ == '__main__':
    framework()

